function onHelp()
{
  window.open('connectedThresholdFilterHelp.html','connectedThresholdFilterHelp',',menubar=no,width=800,resizable=yes,toolbar=no,location=no,directories=no,status=no');

}

function onLoad()
{
  

  // extract threshold filter options into variables
  window.connectedThresholdFilter = window.arguments[0].connectedThresholdFilter;

	// set up preview window
	window.previewWindow = new previewWindow(window.connectedThresholdFilter,"window.previewWindow");

  var belowValue = window.connectedThresholdFilter.belowValue;
  var aboveValue = window.connectedThresholdFilter.aboveValue;
  var replaceValue = window.connectedThresholdFilter.replaceValue;
  var xSeed = window.connectedThresholdFilter.seedValues[0];
  var ySeed = window.connectedThresholdFilter.seedValues[1];
    
  // create objects to reference the sliders 
  var belowValueSlider = document.getElementById("below-value-slider");
  var aboveValueSlider = document.getElementById("above-value-slider");
  var replaceValueSlider = document.getElementById("replace-value-slider");
  
  // set position of sliders

  var maxpos = belowValueSlider.getAttribute("maxpos");
 	belowValueSlider.setAttribute("curpos",belowValue * maxpos);
  maxpos = aboveValueSlider.getAttribute("maxpos");
	aboveValueSlider.setAttribute("curpos",aboveValue * maxpos);
  maxpos = replaceValueSlider.getAttribute("maxpos");
	replaceValueSlider.setAttribute("curpos",replaceValue * maxpos);

  // add listeners to the sliders
  belowValueSlider.addEventListener("DOMAttrModified", below_value_slider, false);
  aboveValueSlider.addEventListener("DOMAttrModified", above_value_slider, false);
  replaceValueSlider.addEventListener("DOMAttrModified", replace_value_slider, false);

  // set initial values of textboxes
  document.getElementById("below-value-textbox").setAttribute("value",belowValue);
  document.getElementById("above-value-textbox").setAttribute("value",aboveValue);
  document.getElementById("replace-value-textbox").setAttribute("value",replaceValue);
  document.getElementById("x-seed-textbox").setAttribute("value",xSeed);
  document.getElementById("y-seed-textbox").setAttribute("value",ySeed);
  
 	// refocus window so that fragmented image updates
	// note we have to delay as the window is not actually drawn until AFTER the onload
	// function is executed

	setTimeout('self.focus()',20);

}

function onClose() {

}

function onCancel() {
	window.previewWindow.destroyPreviewWindow();
}


function getSeedValues() {

	// use selected node to set seed
	window.connectedThresholdFilter.set_seed();

	// reload values and update sliders

  var belowValue = window.connectedThresholdFilter.belowValue;
  var aboveValue = window.connectedThresholdFilter.aboveValue;
  var xSeed = window.connectedThresholdFilter.seedValues[0];
  var ySeed = window.connectedThresholdFilter.seedValues[1];

  // create objects to reference the sliders 
  var belowValueSlider = document.getElementById("below-value-slider");
  var aboveValueSlider = document.getElementById("above-value-slider");

	var maxpos = belowValueSlider.getAttribute("maxpos");
 	belowValueSlider.setAttribute("curpos",belowValue * maxpos);
  maxpos = aboveValueSlider.getAttribute("maxpos");
	aboveValueSlider.setAttribute("curpos",aboveValue * maxpos);
	
  document.getElementById("below-value-textbox").setAttribute("value",belowValue);
  document.getElementById("above-value-textbox").setAttribute("value",aboveValue);
  document.getElementById("x-seed-textbox").setAttribute("value",xSeed);
  document.getElementById("y-seed-textbox").setAttribute("value",ySeed);

	window.previewWindow.autoPreview();
}

// Called once if and only if the user clicks OK
function onOK() {

	window.connectedThresholdFilter.belowValue = document.getElementById("below-value-textbox").value;
	window.connectedThresholdFilter.aboveValue = document.getElementById("above-value-textbox").value;
	window.connectedThresholdFilter.replaceValue = document.getElementById("replace-value-textbox").value;
	window.connectedThresholdFilter.seedValues[0] = document.getElementById("x-seed-textbox").value;
	window.connectedThresholdFilter.seedValues[1] = document.getElementById("y-seed-textbox").value;

	window.connectedThresholdFilter.apply_filter();
 
	// update preview window
	window.previewWindow.onPreview();

  return false;

}



function below_value_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var belowValueSlider = document.getElementById("below-value-slider");
  var aboveValueSlider = document.getElementById("above-value-slider");

  // These attributes must be specified in the xul so that they are fetchable
  belowValueSlider.maxValue = belowValueSlider.getAttribute("maxpos");
  belowValueSlider.value = belowValueSlider.getAttribute("curpos");
  aboveValueSlider.value = aboveValueSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (belowValueSlider.previousValue != belowValueSlider.value)
    {

      belowValueSlider.previousValue = belowValueSlider.value;

      // generate value between 0 and 1
      var belowValue = 1.0 * belowValueSlider.value /
				belowValueSlider.maxValue;
		
      // should use set function eventually, currently just setting value 
      window.connectedThresholdFilter.belowValue = belowValue;

      // update text box
      document.getElementById("below-value-textbox").setAttribute("value",belowValue);
		

    }

	window.previewWindow.autoPreview();
}


function above_value_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var aboveValueSlider = document.getElementById("above-value-slider");
  var belowValueSlider = document.getElementById("below-value-slider");

  // These attributes must be specified in the xul so that they are fetchable
  aboveValueSlider.maxValue = aboveValueSlider.getAttribute("maxpos");
  aboveValueSlider.value = aboveValueSlider.getAttribute("curpos");
  belowValueSlider.value = belowValueSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (aboveValueSlider.previousValue != aboveValueSlider.value)
    {

      aboveValueSlider.previousValue = aboveValueSlider.value;

      // generate value between 0 and 1
      var aboveValue = 1.0 * aboveValueSlider.value /
				aboveValueSlider.maxValue;
		
      window.connectedThresholdFilter.aboveValue = aboveValue;

      // update text box
      document.getElementById("above-value-textbox").setAttribute("value",aboveValue);

    }

	window.previewWindow.autoPreview();
}

function replace_value_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var replaceValueSlider = document.getElementById("replace-value-slider");

  // These attributes must be specified in the xul so that they are fetchable
  replaceValueSlider.maxValue = replaceValueSlider.getAttribute("maxpos");
  replaceValueSlider.value = replaceValueSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (replaceValueSlider.previousValue != replaceValueSlider.value)
    {
      replaceValueSlider.previousValue = replaceValueSlider.value;

      // generate value between 0 and 1
      var replaceValue = 1.0 * replaceValueSlider.value /
				replaceValueSlider.maxValue;
		
      window.connectedThresholdFilter.replaceValue = replaceValue;

      // update text box
      document.getElementById("replace-value-textbox").setAttribute("value",replaceValue);

    }

	window.previewWindow.autoPreview();

}
