function onHelp()
{
  window.open('generalThresholdFilterHelp.html','generalThresholdFilterHelp',',menubar=no,width=800,resizable=yes,toolbar=no,location=no,directories=no,status=no');

}

function onLoad()
{
  
	window.ThresholdMode = {	
		BELOW: 0,
		ABOVE: 1,
		OUTSIDE: 2
	}

  // extract threshold filter options into variables
  window.generalThresholdFilter = window.arguments[0].generalThresholdFilter;

	// set up preview window
	window.previewWindow = new previewWindow(window.generalThresholdFilter,"window.previewWindow");

  var belowValue = window.generalThresholdFilter.belowValue;
  var aboveValue = window.generalThresholdFilter.aboveValue;
  var outsideValue = window.generalThresholdFilter.outsideValue;

  var mode = window.generalThresholdFilter.mode;   
	var modeElementId;

	switch(mode) {
	case window.ThresholdMode.BELOW:
		modeElementId = "threshold-below";
		break;
	case window.ThresholdMode.ABOVE:
		modeElementId = "threshold-above";
		break;
	case window.ThresholdMode.OUTSIDE:
		modeElementId = "threshold-outside";
		break;
	default:
		modeString = "threshold-below";
	}
	
  document.getElementById("select-mode").selectedItem = document.getElementById(modeElementId);
  
  
  // create objects to reference the sliders and radio group
  var belowValueSlider = document.getElementById("below-value-slider");
  var aboveValueSlider = document.getElementById("above-value-slider");
  var outsideValueSlider = document.getElementById("outside-value-slider");
  
  // set position of sliders

	// note there is a wierd bug which means the first call to setAttribute for a slider
	// will fail if the value is set to 0.
	// here we set some initial nonzero values to avoid this problem

	// now replace the initial values with the actual slider postions.
  var maxpos = belowValueSlider.getAttribute("maxpos");
 	belowValueSlider.setAttribute("curpos",belowValue * maxpos);
  maxpos = aboveValueSlider.getAttribute("maxpos");
	aboveValueSlider.setAttribute("curpos",aboveValue * maxpos);
  maxpos = outsideValueSlider.getAttribute("maxpos");
	outsideValueSlider.setAttribute("curpos",outsideValue * maxpos);

  // add listeners to the sliders
  belowValueSlider.addEventListener("DOMAttrModified", below_value_slider, false);
  aboveValueSlider.addEventListener("DOMAttrModified", above_value_slider, false);
  outsideValueSlider.addEventListener("DOMAttrModified", outside_value_slider, false);

  // set initial values of textboxes
  document.getElementById("below-value-textbox").setAttribute("value",belowValue);
  document.getElementById("above-value-textbox").setAttribute("value",aboveValue);
  document.getElementById("outside-value-textbox").setAttribute("value",outsideValue);
  
 	// refocus window so that fragmented image updates
	// note we have to delay as the window is not actually drawn until AFTER the onload
	// function is executed

	setTimeout('self.focus()',20);

}


function onCancel() {
	window.previewWindow.destroyPreviewWindow();
}


// Called once if and only if the user clicks OK
function onOK() {

	// is it faster to fetch textbox values or use the generalThresholdFilter object?
	// both should be up to date
	//	var belowValue = document.getElementById("below-value-textbox").value;
	//	var aboveValue = document.getElementById("above-value-textbox").value;
	//	var outsideValue = document.getElementById("outside-value-textbox").value;

	//	var mode = window.generalThresholdFilter.mode;
	//	var inputField = window.generalThresholdFilter.inputField;


	//	window.generalThresholdFilter.outputField.setTypeThresholdImageFilter(inputField,mode,outsideValue,
	//																																				belowValue,aboveValue);

	window.generalThresholdFilter.apply_filter();
	// update preview window
	window.previewWindow.onPreview();
  return false;


}


function on_radiobutton_threshold_below_toggled()
{
	window.generalThresholdFilter.mode = window.ThresholdMode.BELOW;
	window.previewWindow.autoPreview();
}

function on_radiobutton_threshold_above_toggled()
{
  window.generalThresholdFilter.mode = window.ThresholdMode.ABOVE;
	window.previewWindow.autoPreview();
}

function on_radiobutton_threshold_outside_toggled()
{
  window.generalThresholdFilter.mode = window.ThresholdMode.OUTSIDE;

  // as the outside mode has been selected, update the above value and
  // including the text area and slider so that the above value is not
  // below the below value

  var belowValueSlider = document.getElementById("below-value-slider");
  var aboveValueSlider = document.getElementById("above-value-slider");

  aboveValueSlider.maxValue = aboveValueSlider.getAttribute("maxpos");

  belowValueSlider.value = belowValueSlider.getAttribute("curpos");
  aboveValueSlider.value = aboveValueSlider.getAttribute("curpos");

  // if the above value is not valid, default it to the below value.
  // Invalid values occur for an outside mode filter if the below value is greater 
  // than the above value.
  // check this by doing a subtraction and comparing the result against zero
  // (this ensures a numerical comparison of the two values, rather than comparing them as strings

  if ((aboveValueSlider.value - belowValueSlider.value) < 0 ) {
    aboveValueSlider.value = belowValueSlider.value;
    aboveValueSlider.setAttribute("curpos",aboveValueSlider.value);
    
    aboveValueSlider.previousValue = aboveValueSlider.value;

    // generate value between 0 and 1
    var aboveValue = 1.0 * aboveValueSlider.value /
      aboveValueSlider.maxValue;
    
    // should use set function eventually, currently just setting value 
    window.generalThresholdFilter.aboveValue = aboveValue;

    // update text box
    document.getElementById("above-value-textbox").setAttribute("value",aboveValue);
    
  }

	window.previewWindow.autoPreview();
}


function below_value_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var belowValueSlider = document.getElementById("below-value-slider");
  var aboveValueSlider = document.getElementById("above-value-slider");

  // These attributes must be specified in the xul so that they are fetchable
  belowValueSlider.maxValue = belowValueSlider.getAttribute("maxpos");
  belowValueSlider.value = belowValueSlider.getAttribute("curpos");
  aboveValueSlider.value = aboveValueSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (belowValueSlider.previousValue != belowValueSlider.value)
    {

      // if the value is not valid, set it to the closest valid value.
      // Invalid values occur if an outside mode filter is selected and
      // the below value is greater than the above value
      // check this by doing a subtraction and comparing the result against zero
      // (this ensures a numerical comparison of the two values, rather than comparing them as strings
      if ( (window.generalThresholdFilter.mode == window.ThresholdMode.OUTSIDE) & 
					 (aboveValueSlider.value - belowValueSlider.value) < 0 ) {

	//	alert("below value is: " + belowValueSlider.value + " and above value is: " + aboveValueSlider.value);
				belowValueSlider.value = aboveValueSlider.value;
				belowValueSlider.setAttribute("curpos",belowValueSlider.value);
      }

      belowValueSlider.previousValue = belowValueSlider.value;

      // generate value between 0 and 1
      var belowValue = 1.0 * belowValueSlider.value /
				belowValueSlider.maxValue;
		
      // should use set function eventually, currently just setting value 
      window.generalThresholdFilter.belowValue = belowValue;

      // update text box
      document.getElementById("below-value-textbox").setAttribute("value",belowValue);
		

    }
	window.previewWindow.autoPreview();
}


function above_value_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var aboveValueSlider = document.getElementById("above-value-slider");
  var belowValueSlider = document.getElementById("below-value-slider");

  // These attributes must be specified in the xul so that they are fetchable
  aboveValueSlider.maxValue = aboveValueSlider.getAttribute("maxpos");
  aboveValueSlider.value = aboveValueSlider.getAttribute("curpos");
  belowValueSlider.value = belowValueSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (aboveValueSlider.previousValue != aboveValueSlider.value)
    {
      
      // if the value is not valid, set it to the closest valid value.
      // Invalid values occur if an outside mode filter is selected and
      // the below value is greater than the above value
      // check this by doing a subtraction and comparing the result against zero
      // (this ensures a numerical comparison of the two values, rather than comparing them as strings
      if ( (window.generalThresholdFilter.mode == window.ThresholdMode.OUTSIDE) & 
					 (aboveValueSlider.value - belowValueSlider.value) < 0 ) {
				
				aboveValueSlider.value = belowValueSlider.value;
				aboveValueSlider.setAttribute("curpos",aboveValueSlider.value);
      }

      aboveValueSlider.previousValue = aboveValueSlider.value;

      // generate value between 0 and 1
      var aboveValue = 1.0 * aboveValueSlider.value /
				aboveValueSlider.maxValue;
		
      window.generalThresholdFilter.aboveValue = aboveValue;

      // update text box
      document.getElementById("above-value-textbox").setAttribute("value",aboveValue);

    }
	window.previewWindow.autoPreview();
}

function outside_value_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var outsideValueSlider = document.getElementById("outside-value-slider");

  // These attributes must be specified in the xul so that they are fetchable
  outsideValueSlider.maxValue = outsideValueSlider.getAttribute("maxpos");
  outsideValueSlider.value = outsideValueSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (outsideValueSlider.previousValue != outsideValueSlider.value)
    {
      outsideValueSlider.previousValue = outsideValueSlider.value;

      // generate value between 0 and 1
      var outsideValue = 1.0 * outsideValueSlider.value /
				outsideValueSlider.maxValue;
		
      window.generalThresholdFilter.outsideValue = outsideValue;

      // update text box
      document.getElementById("outside-value-textbox").setAttribute("value",outsideValue);

    }
	window.previewWindow.autoPreview();
}


